<?php

namespace App\Http\Controllers\Master;

use App\Http\Controllers\Controller;
// ganti 1

use App\Models\Master\Merk;
use Illuminate\Http\Request;
use DataTables;
use Auth;
use DB;
use Carbon\Carbon;

// ganti 2
class MerkController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
		
// ganti 3
        return view('master_merk.index');
    }



	
    public function getMerk()
    {
// ganti 5

        $merk = Merk::query();
		
// ganti 6
		
        return Datatables::of($merk)
                ->addIndexColumn()
                ->addColumn('action', function($row) {
                    if (Auth::user()->divisi=="programmer" || Auth::user()->divisi=="owner" || Auth::user()->divisi=="purchase")
                    {
                        $btnPrivilege = 
                        '
                                <a class="dropdown-item" href="merk/edit/?idx=' . $row->NO_ID . '&tipx=edit";
                                <i class="fas fa-edit"></i>
                                    Edit
                                </a>
                                <hr></hr>
                                <a hidden class="dropdown-item btn btn-danger" onclick="return confirm(&quot; Apakah anda yakin ingin hapus? &quot;)" href="merk/delete/'. $row->NO_ID .'">
                                    <i class="fa fa-trash" aria-hidden="true"></i>
                                    Delete
                                </a> 
                        ';
                    } 
                    else
                    {
                        $btnPrivilege = '';
                    }

                    $actionBtn = 
                    '
                    <div class="dropdown show" style="text-align: center">
                        <a class="btn btn-secondary dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                            <i class="fas fa-bars"></i>
                        </a>

                        <div class="dropdown-menu" aria-labelledby="dropdownMenuLink">
 

                            '.$btnPrivilege.'
                        </div>
                    </div>
                    ';
                    
                    return $actionBtn;
                })
                ->rawColumns(['action'])
                ->make(true);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        
        $this->validate($request,
// GANTI 9

        [
                'KODE'       => 'required'
            ]
        );

        // Insert Header

// ganti 10

        $merk = Merk::create(
            [
                'KODE'         => ($request['KODE']==null) ? "" : $request['KODE'],	
                'NAMA'         => ($request['NAMA']==null) ? "" : $request['NAMA'],	
				'USRNM'          => Auth::user()->username,
				'TG_SMP'         => Carbon::now()
            ]
        );

//  ganti 11

        return redirect('/merk')->with('statusInsert', 'Data baru berhasil ditambahkan');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Master\Rute  $rute
     * @return \Illuminate\Http\Response
     */
	 

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Master\Rute  $rute
     * @return \Illuminate\Http\Response
     */

// ganti 15

    public function edit(Request $request , Merk $merk)
    {
		
// ganti 16
		
            $tipx = $request->tipx;

            $idx = $request->idx;
                        


            if ( $idx =='0' && $tipx=='undo'  )
            {
                $tipx ='top';
                
            }
            
            if ($tipx=='search') {
                
                
            $kodex = $request->kodex;
            
            $bingco = DB::SELECT("SELECT NO_ID, KODE from merk
                            where KODE = '$kodex'						 
                            ORDER BY KODE ASC  LIMIT 1" );
                            
                
                if(!empty($bingco)) 
                {
                    $idx = $bingco[0]->NO_ID;
                }
                else
                {
                    $idx = 0; 
                }

                        
            }

            if ($tipx=='top') {
                
            $bingco = DB::SELECT("SELECT NO_ID, KODE from merk      
                            ORDER BY KODE ASC  LIMIT 1" );
                        
                if(!empty($bingco)) 
                {
                    $idx = $bingco[0]->NO_ID;
                }
                else
                {
                    $idx = 0; 
                }
                
            }


            if ($tipx=='prev' ) {
                
            $kodex = $request->kodex;
                
            $bingco = DB::SELECT("SELECT NO_ID, KODE from merk     
                        where KODE < 
                        '$kodex' ORDER BY KODE DESC LIMIT 1" );
                

                if(!empty($bingco)) 
                {
                    $idx = $bingco[0]->NO_ID;
                }
                else
                {
                    $idx = $idx; 
                }
                
                
                
                

            }
            if ($tipx=='next' ) {
                
                    
                $kodex = $request->kodex;

                $bingco = DB::SELECT("SELECT NO_ID, KODE from merk   
                        where KODE > 
                        '$kodex' ORDER BY KODE ASC LIMIT 1" );
                        
                if(!empty($bingco)) 
                {
                    $idx = $bingco[0]->NO_ID;
                }
                else
                {
                    $idx = $idx; 
                }
                
                
            }

            if ($tipx=='bottom') {
            
                $bingco = DB::SELECT("SELECT NO_ID, KODE from merk     
                        ORDER BY KODE DESC  LIMIT 1" );
                        
                if(!empty($bingco)) 
                {
                    $idx = $bingco[0]->NO_ID;
                }
                else
                {
                    $idx = 0; 
                }
                
                
            }


            if ( $tipx=='undo' || $tipx=='search' )
            {

                $tipx ='edit';
                
            }

            

            if ( $idx != 0 ) 
            {
                $merk = Merk::where('NO_ID', $idx )->first();	
            }
            else
            {
                $merk = new Merk;			 
            }

            $data = [
                        'header' => $merk,
                    ];				
            return view('master_merk.edit', $data)->with(['tipx' => $tipx, 'idx' => $idx ]);

    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Master\Rute  $rute
     * @return \Illuminate\Http\Response
     */

// ganti 18

    public function update(Request $request, Merk $merk )
    {
		
        $this->validate($request,
        [		
// ganti 19
                'KODE'       => 'required'
            ]
        );
		
        
		$tipx = 'edit';
		$idx = $request->idx;
		
        $lokasi->update(
            [
              
                'NAMA'          => ($request['NAMA']==null) ? "" : $request['NAMA'],		
				'USRNM'          => Auth::user()->username,
				'TG_SMP'         => Carbon::now()
            ]
        );
		

        return redirect('/merk')->with('status', 'Data baru berhasil diedit');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Master\Rute  $rute
     * @return \Illuminate\Http\Response
     */
	 
// ganti 22
	 
    public function destroy(Merk $merk)
    {

// ganti 23
        $deleteMerk = Merk::find($merk->NO_ID);

// ganti 24

        $deleteMerk->delete();

// ganti 
        return redirect('/merk')->with('status', 'Data berhasil dihapus');
		
		
    }


    public function cekMerk(Request $request)
    {
        $getItem = DB::SELECT('select count(*) as ADA from merk where KODE ="' . $request->KODE . '"');

        return $getItem;
    }
	
}
